#include <ellen/ln.h>
#include <fat.h>
#include <nds/bios.h>
#include <nds/system.h>
#include <nds/interrupts.h>
		
#include "logoPal_bin.h"
#include "logoTiles_bin.h"
		
void lnVideoVblank()
{
	// Placeholder for now
}
		
void lnVideoInit()
{
	powerSET(POWER_ALL_2D);
		
	DISPLAY_CR		=	MODE_0_2D;
	SUB_DISPLAY_CR	=	MODE_0_2D;
		
	irqInit();
	irqEnable(IRQ_VBLANK);
	irqSet(IRQ_VBLANK, lnVideoVblank);
}
		
	// Main entry point for the program 
int main()
{	
		// Inits libellen
	lnVideoInit();
		
		// Inits sprite handling
	lnSpritesInit();
	lnBackgroundInit();
		
		// FAT Must be inited if we want to use GIF loading
	fatInitDefault();
		
		// Create a sprite with pre-converted data from RAM
	lnSpriteCreate(SCREEN_MAIN, SPRSIZE_32x32, COLMODE_16, logoTiles_bin, logoPal_bin);
		// Create a sprite from a GIF file on FAT device
	lnSprite* spriteFromGif = lnSpriteFromGIF(SCREEN_MAIN, gifHandlerLoad("/logo.gif"));
	spriteFromGif->posY = 32 + 16;
		
		// Main loop
	while(1) {
			
			
		lnSpritesUpdate();
		swiWaitForVBlank();
	}
		
	return 0;
}
