#include "ln.h"
		
#ifndef __BACKGROUND_H__
#define __BACKGROUND_H__
		
// ----------------- Defines	-----------------
		
/**
 * Number of tilebases available per screen
 * @note This is a virtual number and should not be consider what is actually \
	there. Map bases and VRAM managment rules still apply!
 */
#define LN_BG_TILEBASE_COUNT		(16)
		
#define LN_BG_TILECOUNT_16			(512)
#define LN_BG_TILECOUNT_256			(512)
#define LN_BG_TILECOUNT_COLMODE(c)	(LN_BG_TILECOUNT_256 >> (c))
		
#define SIZEOF_TILEBASE(c)			(LN_BG_TILECOUNT_COLMODE(c) * SIZEOF_TILE_COLMODE(c))
#define SIZEOF_TILEBASE_16			(SIZEOF_TILEBASE(COLMODE_16))
#define SIZEOF_TILEBASE_256			(SIZEOF_TILEBASE(COLMODE_256))
		
/**
 * Number of map bases per screen.
 */
#define LN_BG_MAPBASE_COUNT			(16)
		

		
// ----------------- Types		-----------------
		
typedef enum
{
	BG_0,
	BG_1,
	BG_2,
	BG_3,
		
	LN_BG_COUNT,
		
} tBgNumber;
		
typedef enum
{
	BGSIZE_256x256,
	BGSIZE_512x256,
	BGSIZE_256x512,
	BGSIZE_512x512,
		
} tBgSize;
		
typedef union
{
	
		
} tBgBuffer, *pBgBuffer;
		
// ----------------- Data		-----------------
		
		
// ----------------- Functions	-----------------
		
void lnBackgroundInit();
		
bool lnBackgroundIsActive(tBgNumber bgNumber);
		
void lnBackgroundSetPalette(tScreen cScreen, tBgNumber bgNumber, tColMode colMode, const void* bgPal);
		
void lnBackgroundSetGraphics(tScreen cScreen, tBgNumber bgNumber, tBgSize bgSize, tColMode colMode, const void* bgMap, const void* bgTiles);
		
void lnBackgroundCreate(tScreen cScreen, tBgNumber bgNumber, tBgSize bgSize, tColMode colMode, const void* bgMap, const void* bgTiles, const void* bgPal);
		
#endif
